
import
  preserves, std/tables

type
  WebsocketArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef
    `url`*: string

  WebsocketArguments* {.preservesRecord: "websocket".} = object
    `field0`*: WebsocketArgumentsField0

  JsonTranslatorArgumentsField0* {.preservesDictionary.} = object
    `argv`*: seq[string]
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  JsonTranslatorArguments* {.preservesRecord: "json-stdio-translator".} = object
    `field0`*: JsonTranslatorArgumentsField0

  JsonTranslatorConnected* {.preservesRecord: "connected".} = object
    `path`*: string

  JsonSocketTranslatorArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef
    `socket`*: string

  JsonSocketTranslatorArguments* {.preservesRecord: "json-socket-translator".} = object
    `field0`*: JsonSocketTranslatorArgumentsField0

  WebhooksArgumentsField0* {.preservesDictionary.} = object
    `endpoints`*: Table[seq[string], EmbeddedRef]
    `listen`*: Tcp

  WebhooksArguments* {.preservesRecord: "webhooks".} = object
    `field0`*: WebhooksArgumentsField0

  FileSystemUsageArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  FileSystemUsageArguments* {.preservesRecord: "file-system-usage".} = object
    `field0`*: FileSystemUsageArgumentsField0

  SqliteArgumentsField0* {.preservesDictionary.} = object
    `database`*: string
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  SqliteArguments* {.preservesRecord: "sqlite".} = object
    `field0`*: SqliteArgumentsField0

  CacheArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef
    `lifetime`*: float

  CacheArguments* {.preservesRecord: "cache".} = object
    `field0`*: CacheArgumentsField0

  XmlTranslatorArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  XmlTranslatorArguments* {.preservesRecord: "xml-translator".} = object
    `field0`*: XmlTranslatorArgumentsField0

  PostgreConnectionParameter* {.preservesTuple.} = object
    `key`*: string
    `val`*: string

  PostgreArgumentsField0* {.preservesDictionary.} = object
    `connection`*: seq[PostgreConnectionParameter]
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  PostgreArguments* {.preservesRecord: "postgre".} = object
    `field0`*: PostgreArgumentsField0

  PulseArgumentsField0* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: EmbeddedRef

  PulseArguments* {.preservesRecord: "pulse".} = object
    `field0`*: PulseArgumentsField0

  Tcp* {.preservesRecord: "tcp".} = object
    `host`*: string
    `port`*: BiggestInt

proc `$`*(x: WebsocketArguments | JsonTranslatorArguments |
    JsonTranslatorConnected |
    JsonSocketTranslatorArguments |
    WebhooksArguments |
    FileSystemUsageArguments |
    SqliteArguments |
    CacheArguments |
    XmlTranslatorArguments |
    PostgreConnectionParameter |
    PostgreArguments |
    PulseArguments |
    Tcp): string =
  `$`(toPreserves(x))

proc encode*(x: WebsocketArguments | JsonTranslatorArguments |
    JsonTranslatorConnected |
    JsonSocketTranslatorArguments |
    WebhooksArguments |
    FileSystemUsageArguments |
    SqliteArguments |
    CacheArguments |
    XmlTranslatorArguments |
    PostgreConnectionParameter |
    PostgreArguments |
    PulseArguments |
    Tcp): seq[byte] =
  encode(toPreserves(x))
